#include <iostream>

using namespace std;

int main()
{
    int n,q;
    cin>>n>>q;
    int d[n],p[n];
    int d2[n];
    cin>>d[0]>>p[0];
    d2[0]=d[0];
    for(int i=1;i<n;i++)
    {
        cin>>d[i]>>p[i];
        d2[i]=d[i]+d2[i-1];
    }
    for(int i=0;i<q;i++)
    {
        int hp;
        cin>>hp;
        if(p[0]==0){
            if(hp>d2[n-1]) cout<<-1<<'\n';
            else if(hp<d2[0]) cout<<1<<'\n';
            else{
                int d=0,g=n-1,s,raz=hp,poz=0;
                while (true)
                {
                    s=(d+g)/2;
                    if (d2[s]-hp>0)
                    {
                        if(d2[s]-hp<raz)
                        {
                            raz=d2[s]-hp;
                            poz=s;
                        }
                        g=s-1;
                    }
                    else if (d2[s]-hp<0)
                    {
                        if(d2[s+1]-hp>0 || d2[s+1]==hp)
                        {
                            poz=s+1;
                            break;
                        }
                        d=s+1;
                    }
                    else{
                        poz=s;
                        break;
                    }
                    if(d>g){
                        poz=s;
                        break;
                    }
                }
                cout<<poz+1<<'\n';
            }
        }

    }
}